/* TCPEchoClient.c */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 100


main(int argc, char **argv)
{ 
struct hostent *host;	
struct sockaddr_in servaddr; 
int  sd, conn_ok, nread;
char buff[DIM_BUFF];


if (argc!=3) {
	printf("Error! Usage: echoTCP nodoserver msg\n");
	exit(1);
}

memset((char *)&servaddr, 0, sizeof(servaddr));

sd=socket(AF_INET, SOCK_STREAM, 0);
if(sd<0) {perror("apertura socket"); exit(1);}
else printf("TCPClient: creata la socket con fd=%d\n", sd);

servaddr.sin_family = AF_INET;

host = gethostbyname (argv[1]);
if (host == NULL) 
{printf("%s not found in /etc/hosts\n", argv[1]); exit(1);}

printf("TCPClient: indirizzo server : %s \n", host->h_name);

servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
servaddr.sin_port = 12345;

conn_ok=connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr));
if(conn_ok<0) { perror("Errore in connect"); exit(1);}
printf("TCPClient: connect ok\n");

if (write(sd, argv[2], strlen(argv[2])+1)<0)	
{perror("write"); exit(1);}	
printf("TCPClient: inviato msg %s \n", argv[2]);	

if (nread=read(sd, buff, DIM_BUFF)<0)	
{perror("read"); exit(1);}	
printf("TCPClient: ricevo echo -> %s\n", buff);



close(sd);
exit(0);
}


