/* UDPEchoClient.c */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 100



main(int argc, char **argv)
{ 
struct hostent *host;	
struct sockaddr_in servaddr; 
int  sd, i, addrlen;
char buff[DIM_BUFF];


if (argc!=3) {
	printf("Error! Usage: echoUDP nodoserver msg\n");
	exit(1);
}


memset((char *)&servaddr, 0, sizeof(servaddr));

sd=socket(AF_INET, SOCK_DGRAM, 0);
if(sd<0) {perror("apertura socket"); exit(1);}
else printf("UDPClient: creata la socket con fd=%d\n", sd);

servaddr.sin_family = AF_INET;

host = gethostbyname (argv[1]);
if (host == NULL) 
{printf("%s not found in /etc/hosts\n", argv[1]); exit(1);}

printf("UDPClient: indirizzo server: %s \n", host->h_name);

servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
servaddr.sin_port = 12345;

if (sendto(sd, argv[2], (strlen(argv[2]) + 1), 0, (struct sockaddr *)&servaddr, sizeof(servaddr))<0)
	{perror("sendto"); exit(1);}
printf("UDPClient: inviato msg %s \n", argv[2]);	


if (recvfrom(sd, buff, DIM_BUFF, 0, (struct sockaddr *)&servaddr, &addrlen)<0)
	{perror("recvfrom"); exit(1);}
printf("UDPClient: ricevo echo -> %s\n", buff);


close(sd);
exit(0);
}

